#version 330




in vec3 position;
in vec3 normal;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

out vec3 P;
out vec3 N;



void main() {
	mat4 normalMatrix = inverse(transpose(modelMatrix));
	vec3 worldNormal = normalize( (normalMatrix * vec4(normal, 0)).xyz );
	mat4 mvp = projectionMatrix * viewMatrix * modelMatrix;

	N = normalize(worldNormal);
	P = ( modelMatrix * vec4(position, 1) ).xyz;

	gl_Position = mvp * ( vec4(position,1));

}
